////////////////////////////////////
//																//
// HW #9, Part b, Class Template  //
//																//
//				Test Driver							//
//																//
////////////////////////////////////

#include <iostream.h>
#include "Array.h"
#include "VString.h"
#include "Fraction.h"
#include "Patron.h"


void main()
{
	
	cout << "** Testing Type Char **\n";
	char array1[13] = {'B','C','D','E','F','G','H','I','J','K','L','M','N'};
	Array <char>a;
	cout << "Initially, array a is: " << a << endl;
	a.Add('a');
	a.Add('*');
	cout << "After adding two elments, array a is: " << a << endl;
	a.Add(array1,13);
	cout << "After adding an array, array a is: " << a << endl;
		
	// test on Remove
	a.Remove(2);
	cout << "After removing the Second element: " << a << endl;


	// test on Search 
	cout << "After searching for elment 'H', ";
	if (a.Search('H'))
		cout << "Element was found" << endl;
	else
		cout << "Element was not found" << endl;

	// test copy constructor
	Array<char>b(a);
	cout << "After b(a), array b is: " << b << endl;
	
	// op=
	Array<char>c;
	c = b;
	cout << "After setting c=b, array c is: " << c << endl;

	// op==
	Array<char>d;
	d.Add('A');
	cout << "array d: " << d << endl;
	d = c;
	cout << "array d: " << d << endl;
	if (c == d)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	if (c != d)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "c[10] = " << c[10] << endl;

	// get Size of array
	cout << "Size of array c is: " << c.Size() << endl;


	// ***** Type Integer *****
	cout << "\n** Testing Type Integer **\n";
	int array2[4] = {1,2,3,4};
	Array <int>a1;
	cout << "Initially, array a1 is: " << a1 << endl;
	a1.Add(10);
	a1.Add(10);
	cout << "After adding two elments, array a1 is: " << a1 << endl;
	a1.Add(array2,4);
	cout << "After adding an array, array a1 is: " << a1 << endl;
		
	// test on Remove
	a1.Remove(3);
	cout << "After removing the third element: " << a1 << endl;


	// test on Search 
	cout << "After searching for elment '8', ";
	if (a1.Search(8))
		cout << "Element was found" << endl;
	else
		cout << "Element was not found" << endl;

	// test copy constructor
	Array<int>b1(a1);
	cout << "After b1(a1), array b1 is: " << b1 << endl;
	
	// op=
	Array<int>c1;
	c1 = b1;
	cout << "After setting c1=b1, array c1 is: " << c1 << endl;

	// op==
	Array<int>d1;
	d1.Add(23);
	cout << "array d: " << d1 << endl;
	if (c1 == d1)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	if (c1 != b1)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "c1[5] = " << c1[5] << endl;

	// get Size of array
	cout << "Size of array c1 is: " << c1.Size() << endl;


	// ***** Type Float *****
	cout << "\n** Testing Type Float **\n";
	float array3[7] = {1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7};
	Array <float>a2;
	cout << "Initially, array a3 is: " << a2 << endl;
	a2.Add(8.8);
	a2.Add(9.9);
	cout << "After adding two elments, array a2 is: " << a2 << endl;
	a2.Add(array3,7);
	cout << "After adding an array, array a2 is: " << a2 << endl;
		
	// test on Remove
	a2.Remove(5);
	cout << "After removing the fifth element: " << a2 << endl;


	// test on Search 
	cout << "After searching for elment '7.7', ";
	if (a2.Search(7.7))
		cout << "Element was found" << endl;
	else
		cout << "Element was not found" << endl;

	// test copy constructor
	Array<float>b2(a2);
	cout << "After b2(a2), array b2 is: " << b2 << endl;
	
	// op=
	Array<float>c2;
	c2 = b2;
	cout << "After setting c2=b2, array c2 is: " << c2 << endl;

	// op==
	Array<float>d2;
	d2.Add(23.23);
	cout << "array d2: " << d2 << endl;
	if (c2 == d2)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	if (c2 != b2)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "c2[6] = " << c2[6] << endl;

	// get Size of array
	cout << "Size of array c2 is: " << c2.Size() << endl;


	// ***** Type VString *****
	cout << "\n** Testing Type VString **\n";
	VString vsArray[3] = {"This", "Is", "Cool"};
	
	Array <VString>vs1;

	cout << "Initially, array vs1 is: " << vs1 << endl;
	vs1.Add("Beer");
	vs1.Add("Bar");
	cout << "After adding two elments, array vs1 is: " << vs1 << endl;
	vs1.Add(vsArray,3);
	cout << "After adding an array, array vs1 is: " << vs1 << endl;
		
	// test on Remove
	vs1.Remove(2);
	vs1.Remove(2);
	cout << "After removing the second and third elements: " << vs1 << endl;

	// test on Search 
	cout << "After searching for elment 'Beer', ";
	if (vs1.Search("Beer"))
		cout << "Element was found" << endl;
	else
		cout << "Element was not found" << endl;

	// test copy constructor
	Array<VString>vs2(vs1);
	cout << "After vs2(vs1), array vs2 is: " << vs2 << endl;
	
	// op=
	Array<VString>vs3;
	VString vsArray2[5]={"Can","I","Have","One","?"};
	vs3 = vs2;
	vs3.Add(vsArray2,5);	
	cout << "After setting vs3=vs2, array vs3 is: " << vs3 << endl;

	// op==
	Array<VString>vs4;
	vs4.Add("Yellow");
	vs4.Add("Howdy");
	cout << "array vs4: " << vs4 << endl;
	if (vs3 == vs4)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	if (vs3 != vs4)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "vs3[6] = " << vs3[6] << endl;

	// get Size of array
	cout << "Size of array vs3 is: " << vs3.Size() << endl;


	
	// ***** Type Fraction *****
	cout << "\n** Testing Type Fraction **\n";
	Fraction fArray[4] = {Fraction(1,2),Fraction(3,4),Fraction(6,7),Fraction(3,2)};
	
	Array <Fraction>f1;

	cout << "Initially, array f1 is: " << f1 << endl;
	f1.Add(Fraction(5,6));
	f1.Add(Fraction(6,5));
	cout << "After adding two elments, array f1 is: " << f1 << endl;
	f1.Add(fArray,4);
	cout << "After adding an array, array f1 is: " << f1 << endl;
		
	// test on Remove
	f1.Remove(2);
	f1.Remove(2);
	cout << "After removing the second and third elements: " << f1 << endl;

	// test on Search 
	cout << "After searching for element '6/7', ";
	if ( f1.Search(Fraction(6,7)) )
		cout << "Element was found" << endl;
	else
		cout << "Element was not found" << endl;

	// test copy constructor
	Array<Fraction>f2(f1);
	cout << "After f2(f1), array f2 is: " << f2 << endl;
	
	// op=
	Array<Fraction>f3;
	f3 = f2;
	cout << "After setting f3=f2, array f3 is: " << f3 << endl;

	// op==
	Array<Fraction>f4;
	f4.Add(Fraction(33,44));
	f4.Add(Fraction(23,24));
	cout << "array f4: " << f4 << endl;
	if (f3 == f4)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	f4 = f3;
	if (f3 != f4)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "f3[3] = " << f3[3] << endl;

	// get Size of array
	cout << "Size of array f3 is: " << f3.Size() << endl;

	
	// ***** Type Patron *****
	cout << "\n** Testing Type Patron **\n";
	Patron pArray[2] = {Patron("Abe","Neto",26), Patron("Chung","Chau",24)};
	
	
	Array<Patron> p1;

	cout << "Initially, array p1 contains: " << p1 << endl;
	cout << "And its size is " << p1.Size() << endl;

	p1.Add(Patron("Quynh","Nguyen",28));
	p1.Add(Patron("Adonis","Katicher",30));
	cout << "After adding two elments, array p1 is: " << p1 << endl;
	p1.Add(pArray,2);
	cout << "After adding an array, array p1 is: " << p1 << endl;
		
	// test on Remove
	p1.Remove(2);
	cout << "After removing the second Patron: " << p1 << endl;

	// test on Search 
	cout << "Search for Patron 'Abe Neto'. ";
	if ( p1.Search(Patron("Abe","Neto",26)) )
		cout << "Patron was found" << endl;
	else
		cout << "Patron was not found" << endl;

	// test copy constructor
	Array<Patron> p2(p1);
	cout << "After p2(p1), array p2 is: " << p2 << endl;

	// op=
	Array<Patron> p3;
	p3 = p2;
	cout << "After setting p3=p2, array p3 is: " << p3 << endl;

	// op==
	Array<Patron> p4;
	p4.Add(Patron("Abe","Neto",26));
	p4.Add(Patron("Ben","Yim",25));
	cout << "array p4: " << p4 << endl;
	if (p3 == p4)
		cout << "The two arrays are equal\n";
	else
		cout << "The two arrays are different\n";

	// op!=
	p4 = p3;
	if (p3 != p4)
		cout << "The two arrays are different\n";
	else
		cout << "The two arrays are equal\n";

	//op[]
	cout << "p3[2] = " << p3[2] << endl;

	// get Size of array
	cout << "Size of array p3 is: " << p3.Size() << endl;

	cout << endl;
}