//////////////////////////////////////
// Array Template Main Driver				//
//																	//
//	Chungho Chau	5/19/1998 				//
//																	//
//////////////////////////////////////

#include "array.h"
#include "VString.h"
#include <iostream.h>

void main()
{
	cout << "++---------------------++" << endl;
	cout << "++ Testing type 'char' ++" << endl;
	cout << "++---------------------++" << endl;
	
	Array<char> a1;
	a1.Add('G');
	a1.Add('R');
	a1.Add('E');
	a1.Add('A');
	a1.Add('T');
	a1.Add(' ');
	cout << "Array a1 is: " << a1 << endl;

	Array<char> a2(a1);

	cout << "Array a2 is: " << a2 << endl;

	char cArray[6] = {'A','D','O','N','I','S'};

	Array<char> a3(a2);

	a3.Add(cArray,6);

	cout << "Array a3 is: " << a3 << endl;
	cout << "Number of Element in a3 is " << a3.GetSize() << endl;

	cout << Array<char>::GetArrayCount() << " array(s) instantiated\n";

	cout << "Comparing a1 and a2: ";
	if ( a1==a2)
		cout << "Equal\n";
	else
		cout << "Different\n";

	
	cout << endl << endl;
	cout << "++---------------------++" << endl;
	cout << "++ Testing type 'int'  ++" << endl;
	cout << "++---------------------++" << endl;
	
	Array<int> b1;
	b1.Add(1);
	b1.Add(2);
	b1.Add(3);
	cout << "Array b1 is: " << b1 << endl;

	Array<int> b2(b1);

	cout << "Array b2 is: " << b2 << endl;

	int iArray[5] = {4,5,6,7,8};

	Array<int> b3(b2);

	b3.Add(iArray,5);

	cout << "Array b3 is: " << b3 << endl;
	cout << "Number of Element in b3 is " << b3.GetSize() << endl;

	cout << Array<int>::GetArrayCount() << " array(s) instantiated\n";

	cout << "Comparing b1 and b3: ";
	if ( b1==b3)
		cout << "Equal\n";
	else
		cout << "Different\n";


	cout << endl << endl;
	cout << "++------------------------++" << endl;
	cout << "++ Testing type 'VString' ++" << endl;
	cout << "++------------------------++" << endl;
	
	Array<VString> v0,v1;
	v1.Add("Chung");
	v1.Add("Ho");
	v1.Add("Chau");
	cout << "Array v0 is: " << v0 << endl;
	cout << "Array v1 is: " << v1 << endl;

	Array<VString> v2(v1);

	cout << "Array v2 is: " << v2 << endl;

	VString vArray1[3] = {"Is","Quite","Spooky"};
	VString vArray2[3] = {"Go","Lakers","!!!"};

	Array<VString> v3(v2), v4;

	v3.Add(vArray1,3);
	cout << "Array v3 is: " << v3 << endl;

	v4.Add(vArray2,3);
	cout << "Array v4 is: " << v4 << endl;

	cout << "Number of Element in v3 is " << v3.GetSize() << endl;

	cout << Array<VString>::GetArrayCount() << " array(s) instantiated\n";

	cout << "Comparing v2 and v3: ";
	if ( v2==v3)
		cout << "Equal\n";
	else
		cout << "Different\n";

	cout << endl;
}